<?php

namespace App\Http\Controllers\Admin;

use App\Http\Requests\PartyCreateRequest;
use App\Http\Requests\PartyUpdateRequest;
use App\Models\Party;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Role;

class PartyController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('admin.party.index');
    }

    public function data(Request $request)
    {
        $res = Party::paginate($request->get('limit', 30))->toArray();
        $data = [
            'code' => 0,
            'msg'   => '正在请求中...',
            'count' => $res['total'],
            'data'  => $res['data']
        ];
        return response()->json($data);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.party.create')->with(['party'=>array()]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(PartyCreateRequest $request)
    {
        $data = $request->all();
        if (Party::create($data)){
            return redirect()->to(route('admin.party'))->with(['status'=>'添加成功']);
        }
        return redirect()->to(route('admin.party'))->withErrors('系统错误');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $party = Party::where('id', $id)->first();
        return view('admin.party.edit',compact('party'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(PartyUpdateRequest $request, $id)
    {
       // $party = Party::findOrFail($id);

        $data = $request->all();
        if(empty($data['key'])){
            unset($data['key']);
        }
        if(empty($data['secret'])){
            unset($data['secret']);
        }
        $party = Party::findOrFail($id);

        if ($party->update($data)){
            return redirect()->to(route('admin.party'))->with(['status'=>'更新成功']);
        }
        return redirect()->to(route('admin.party'))->withErrors('系统错误');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request)
    {
        $ids = $request->get('ids');
        if (empty($ids)){
            return response()->json(['code'=>1,'msg'=>'请选择删除项']);
        }
        if (Party::destroy($ids)){
            return response()->json(['code'=>0,'msg'=>'删除成功']);
        }
        return response()->json(['code'=>1,'msg'=>'删除失败']);
    }

    /**
     * 分配角色
     */
    public function role(Request $request,$id)
    {
        $party = Party::findOrFail($id);
        $roles = Role::get();
        $hasRoles = $party->roles();
        foreach ($roles as $role){
            $role->own = $party->hasRole($role) ? true : false;
        }
        return view('admin.party.role',compact('roles','party'));
    }

    /**
     * 更新分配角色
     */
    public function assignRole(Request $request,$id)
    {
        $party = Party::findOrFail($id);
        $roles = $request->get('roles',[]);
       if ($party->syncRoles($roles)){
           return redirect()->to(route('admin.party'))->with(['status'=>'更新用户角色成功']);
       }
        return redirect()->to(route('admin.party'))->withErrors('系统错误');
    }

    /**
     * 分配权限
     */
    public function permission(Request $request,$id)
    {
        $party = Party::findOrFail($id);
        $permissions = $this->tree();
        foreach ($permissions as $key1 => $item1){
            $permissions[$key1]['own'] = $party->hasDirectPermission($item1['id']) ? 'checked' : false ;
            if (isset($item1['_child'])){
                foreach ($item1['_child'] as $key2 => $item2){
                    $permissions[$key1]['_child'][$key2]['own'] = $party->hasDirectPermission($item2['id']) ? 'checked' : false ;
                    if (isset($item2['_child'])){
                        foreach ($item2['_child'] as $key3 => $item3){
                            $permissions[$key1]['_child'][$key2]['_child'][$key3]['own'] = $party->hasDirectPermission($item3['id']) ? 'checked' : false ;
                        }
                    }
                }
            }
        }
        return view('admin.party.permission',compact('party','permissions'));
    }

    /**
     * 存储权限
     */
    public function assignPermission(Request $request,$id)
    {
        $party = Party::findOrFail($id);
        $permissions = $request->get('permissions');

        if (empty($permissions)){
            $party->permissions()->detach();
            return redirect()->to(route('admin.party'))->with(['status'=>'已更新用户直接权限']);
        }
        $party->syncPermissions($permissions);
        return redirect()->to(route('admin.party'))->with(['status'=>'已更新用户直接权限']);
    }

}
